=== debian/changelog ===
superlu (5.3.0+dfsg1-2) unstable; urgency=medium

  * upload SuperLU 5.3 to unstable

 -- Drew Parsons <dparsons@debian.org>  Sat, 16 Oct 2021 00:08:35 +0200

superlu (5.3.0+dfsg1-1exp1) experimental; urgency=medium

  * New upstream release.
  * Standards-Version: 4.6.0

 -- Drew Parsons <dparsons@debian.org>  Wed, 06 Oct 2021 17:05:28 +0200
