## superlu 6.0.0+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,4 @@
+
 ######################################################################
 #
 # CMakeLists.txt for SUPERLU
@@ -8,19 +9,21 @@
 cmake_minimum_required(VERSION 2.8.12)
 
 # Project Version	
-project(SuperLU NONE)
-set(VERSION_MAJOR "5")
-set(VERSION_MINOR "3")
+project(SuperLU C)
+set(VERSION_MAJOR "6")
+set(VERSION_MINOR "0")
 set(VERSION_BugFix "0")
 set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_BugFix})
 
 ######################################################################
 #
 # IDEAS: xSDK standards module
-MESSAGE("\nProcess XSDK defaults ...")
-# SET(USE_XSDK_DEFAULTS_DEFAULT TRUE) # Set to false if desired
-INCLUDE("cmake/XSDKDefaults.cmake")
-INCLUDE(CTest)
+#MESSAGE("\nProcess XSDK defaults ...")
+#SET(USE_XSDK_DEFAULTS_DEFAULT TRUE) # Set to false if desired
+#INCLUDE("cmake/XSDKDefaults.cmake")
+set(USE_XSDK_DEFAULTS TRUE)
+include(CTest)
+include(GNUInstallDirs)
 
 ######################################################################
 
@@ -29,26 +32,23 @@
 # Usual initialization stuff
 #
 ######################################################################
-set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)    ## ????
-set(CMAKE_INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib")
-
-#---- For shared library
-
+
+#---- set RPATH handling
 # use, i.e. don't skip the full RPATH for the build tree
-SET(CMAKE_SKIP_BUILD_RPATH  FALSE)
+set(CMAKE_SKIP_BUILD_RPATH FALSE)
 
 # when building, don't use the install RPATH already
 # (but later on when installing)
-SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 
+set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
 
 # the RPATH to be used when installing
 set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
 
 # add the automatically determined parts of the RPATH
 # which point to directories outside the build tree to the install RPATH
-SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
-#----
-
+set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
+
+#---- For shared library
 if (BUILD_SHARED_LIBS)
   message("-- SuperLU will be built as a shared library.")
   set(PROJECT_NAME_LIB_EXPORT libsuperlu.so)
@@ -72,11 +72,7 @@
   set(enable_blaslib_DEFAULT ON)
 endif()
 
-if (NOT CMAKE_INSTALL_PREFIX)
-  set(CMAKE_INSTALL_PREFIX /usr/local)
-endif()
-
-# setup options
+# set up options
 option(enable_internal_blaslib  "Build the CBLAS library" ${enable_blaslib_DEFAULT})
 option(enable_matlabmex "Build the Matlab mex library" OFF)
 option(enable_tests     "Build tests" ON)
@@ -87,11 +83,23 @@
 option(enable_complex16 "Enable complex16 precision library" ON)
 # option(enable_examples  "Build examples" ON)
 
+#-- BLAS
+option(TPL_ENABLE_INTERNAL_BLASLIB  "Build the CBLAS library" ${enable_blaslib_DEFAULT})
+option(TPL_BLAS_LIBRARIES "List of absolute paths to blas libraries [].")
+#-- METIS
+option(TPL_ENABLE_METISLIB   "Build the METIS library" OFF)
+option(TPL_METIS_LIBRARIES "List of absolute paths to METIS link libraries [].")
+option(TPL_METIS_INCLUDE_DIRS "List of absolute paths to METIS include directories [].")
+
 # setup required compiler defines and options.
-## add_definitions(-DPRNTlevel=0 -DAdd_)
 ## get_directory_property( DirDefs COMPILE_DEFINITIONS )
-set(CMAKE_C_FLAGS "-DPRNTlevel=0 -DDEBUGlevel=0 ${CMAKE_C_FLAGS}")
+#set(CMAKE_C_FLAGS "-DPRNTlevel=0 -DDEBUGlevel=0 ${CMAKE_C_FLAGS}")
+
 set(CMAKE_C_FLAGS_RELEASE "-O3" CACHE STRING "")
+
+if(XSDK_INDEX_SIZE EQUAL 64)
+    message("-- Using 64 bit integer for index size.")
+endif()	
 
 ######################################################################
 #
@@ -130,6 +138,56 @@
   endif()
 endif()
 
+#--------------------- METIS ---------------------
+if (TPL_ENABLE_METISLIB)   ## want to use metis
+  if (NOT TPL_METIS_LIBRARIES)
+    message(FATAL_ERROR "TPL_METIS_LIBRARIES option should be set for METIS support to be enabled.")
+  endif()
+
+  if (NOT TPL_METIS_INCLUDE_DIRS)
+    message(FATAL_ERROR "TPL_METIS_INCLUDE_DIRS option be set for METIS support to be enabled.")
+  endif()
+  foreach(dir ${TPL_METIS_INCLUDE_DIRS})
+    if (NOT MINGW AND NOT EXISTS ${dir})
+      message(FATAL_ERROR "METIS include directory not found: ${dir}")
+    endif()
+    set(CMAKE_C_FLAGS "-I${dir} ${CMAKE_C_FLAGS}")
+  endforeach()
+
+  message("-- Enabled support for METIS.")
+  set(METIS_FOUND TRUE)
+
+  set(METIS_LIB ${TPL_METIS_LIBRARIES})
+  # fix up METIS library names
+  string (REPLACE ";" " " METIS_LIB_STR "${METIS_LIB}")
+  set(METIS_LIB_EXPORT ${METIS_LIB_STR})
+else()
+  message("-- Will not link with METIS.")
+endif()
+
+if(TPL_ENABLE_METISLIB AND NOT METIS_FOUND)
+  find_package(METIS)
+  if(METIS_FOUND)
+    set(METIS_LIB METIS::METIS)
+    set(TPL_METIS_INCLUDE_DIRS "")
+  endif()
+endif()
+
+if(METIS_FOUND)
+  set(HAVE_METIS TRUE)
+endif()
+
+
+######################################################################
+#
+# Include directories
+#
+######################################################################
+include_directories(${CMAKE_BINARY_DIR}/SRC) # For superlu_config.h
+if (TPL_METIS_INCLUDE_DIRS)
+  include_directories(${TPL_METIS_INCLUDE_DIRS})  ## metis
+endif ()
+
 ######################################################################
 #
 # Add subdirectories
@@ -147,10 +205,21 @@
   add_subdirectory(TESTING)
 endif()
 
+if(enable_examples)
+  enable_testing()
+  add_subdirectory(EXAMPLE)
+endif()
+
+if (XSDK_ENABLE_Fortran)
+  add_subdirectory(FORTRAN)
+endif()
+
 if(enable_doc)
   message(FATAL_ERROR "Documentation build requested but not implemented.")
   #implement doxygen
 endif()
+
+# Generate various configure files with proper definitions
 
 # file(WRITE "make.defs" "# can be exposed to users"
 #  ${CMAKE_C_COMPILER}  )
@@ -160,3 +229,9 @@
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/superlu.pc.in ${CMAKE_CURRENT_BINARY_DIR}/superlu.pc @ONLY)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/superlu.pc
 	DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
+	
+configure_file(${SuperLU_SOURCE_DIR}/SRC/superlu_config.h.in ${SuperLU_BINARY_DIR}/SRC/superlu_config.h)
+configure_file(${SuperLU_SOURCE_DIR}/SRC/superlu_config.h.in ${SuperLU_SOURCE_DIR}/SRC/superlu_config.h)
+
+# Following is to configure a header file for FORTRAN code
+configure_file(${SuperLU_SOURCE_DIR}/SRC/superlu_config.h.in ${SuperLU_BINARY_DIR}/FORTRAN/superlu_config.h)
