=== debian/changelog ===
superlu (6.0.0+dfsg1-3) unstable; urgency=medium

  * debian patch malloc_PR100.diff applies upstream PR#100 to fix
    Malloc/Calloc definitions. Closes: #1043313.

 -- Drew Parsons <dparsons@debian.org>  Thu, 10 Aug 2023 13:42:56 +0200

superlu (6.0.0+dfsg1-2) unstable; urgency=medium

  * push SuperLU 6 to unstable

 -- Drew Parsons <dparsons@debian.org>  Tue, 01 Aug 2023 14:58:30 +0200

superlu (6.0.0+dfsg1-1exp1) experimental; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Remove unnecessary get-orig-source-target.
  * Drop transition for old debug package migration.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * Remove constraints unnecessary since buster (oldstable):
    + Build-Depends: Drop versioned constraint on gcc.

  [ Drew Parsons ]
  * New upstream release.
    - bump to ABI 6
  * Standards-Version: 4.6.2
  * add debian/source/lintian-overrides to override
    superlu source: source-is-missing [DOC/html/*.html]
    Doc source is in C files (docs were generated by doxygen).

 -- Drew Parsons <dparsons@debian.org>  Sat, 15 Apr 2023 12:04:13 +0200
