=== debian/control ===
--- 
+++ 
@@ -4,16 +4,15 @@
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Drew Parsons <dparsons@debian.org>
 Build-Depends: debhelper-compat (= 13),
- gcc (>= 3.0),
  gfortran,
  cmake,
  libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/xiaoyeli/superlu
 Vcs-Git: https://salsa.debian.org/science-team/superlu.git
 Vcs-Browser: https://salsa.debian.org/science-team/superlu
 
-Package: libsuperlu5
+Package: libsuperlu6
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -43,7 +42,7 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libsuperlu5 (= ${binary:Version}),
+Depends: libsuperlu6 (= ${binary:Version}),
     libopenblas-dev | libatlas-base-dev | libblas-dev | libblas.so,
     ${misc:Depends}
 Suggests: libsuperlu-doc
