=== debian/changelog ===
superlu (6.0.1+dfsg1-1build1) noble; urgency=high

  * No change rebuild for frame pointers (and time_t).

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 18 Apr 2024 19:50:36 +0200

superlu (6.0.1+dfsg1-1) unstable; urgency=medium

  * New upstream release.
    - applies debian patch malloc_PR100.diff
  * manage generated config files in debian/rules
    - dh_clean: remove make.inc (generated from make.inc.in)
    - make copy of SRC/superlu_config.h to enable repeated builds
    - Closes: #1048237

 -- Drew Parsons <dparsons@debian.org>  Mon, 04 Sep 2023 15:10:39 +0200
